diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
index 061fa9d3..2d729f1f 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
@@ -27,17 +27,17 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement4;
+import org.distorted.objectlib.main.MovementTetrahedron;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty4;
+import org.distorted.objectlib.main.TwistyTetrahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistyPyraminx extends Twisty4
+public class TwistyPyraminx extends TwistyTetrahedron
 {
   static final Static3D[] ROT_AXIS = new Static3D[]
          {
@@ -136,7 +136,7 @@ public class TwistyPyraminx extends Twisty4
     {
     if( mQuats==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement4.FACE_AXIS[status],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementTetrahedron.FACE_AXIS[status],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
index 95e88953..5316d7e1 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
@@ -27,17 +27,17 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement6;
+import org.distorted.objectlib.main.MovementHexahedron;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty6;
+import org.distorted.objectlib.main.TwistyHexahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistyRedi extends Twisty6
+public class TwistyRedi extends TwistyHexahedron
 {
   static final Static3D[] ROT_AXIS = new Static3D[]
          {
@@ -113,7 +113,7 @@ public class TwistyRedi extends Twisty6
     {
     if( mQuats==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement6.FACE_AXIS[status],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementHexahedron.FACE_AXIS[status],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
index 666a5a23..dc794786 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
@@ -27,17 +27,17 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement6;
+import org.distorted.objectlib.main.MovementHexahedron;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty6;
+import org.distorted.objectlib.main.TwistyHexahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistyRex extends Twisty6
+public class TwistyRex extends TwistyHexahedron
 {
   static final Static3D[] ROT_AXIS = new Static3D[]
          {
@@ -108,7 +108,7 @@ public class TwistyRex extends Twisty6
     {
     if( mQuats==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement6.FACE_AXIS[status],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementHexahedron.FACE_AXIS[status],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
index 53fe9062..07295e4c 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
@@ -27,17 +27,17 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement6;
+import org.distorted.objectlib.main.MovementHexahedron;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty6;
+import org.distorted.objectlib.main.TwistyHexahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistySkewb extends Twisty6
+public class TwistySkewb extends TwistyHexahedron
 {
   static final Static3D[] ROT_AXIS = new Static3D[]
          {
@@ -109,7 +109,7 @@ public class TwistySkewb extends Twisty6
     {
     if( mQuats==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement6.FACE_AXIS[status],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementHexahedron.FACE_AXIS[status],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare.java
index d253134c..1c7ddb38 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare.java
@@ -26,11 +26,11 @@ import java.io.InputStream;
 
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
-import org.distorted.objectlib.main.Twisty6;
+import org.distorted.objectlib.main.TwistyHexahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-abstract class TwistySquare extends Twisty6
+abstract class TwistySquare extends TwistyHexahedron
 {
   static final float COS15 = (SQ6+SQ2)/4;
   static final float SIN15 = (SQ6-SQ2)/4;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
index dcd5d229..4f8d29f5 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
@@ -24,7 +24,7 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement6;
+import org.distorted.objectlib.main.MovementHexahedron;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -70,7 +70,7 @@ public class TwistySquare1 extends TwistySquare
     {
     if( mQuats==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement6.FACE_AXIS[status],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementHexahedron.FACE_AXIS[status],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
index 73ece3b5..33fdefd3 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
@@ -27,17 +27,17 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement12;
+import org.distorted.objectlib.main.MovementDodecahedron;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty12;
+import org.distorted.objectlib.main.TwistyDodecahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistyUltimate extends Twisty12
+public class TwistyUltimate extends TwistyDodecahedron
 {
   private static final float A = (float)Math.sqrt(21*SQ5+47);
   private static final float B = SQ6*(5*SQ5+11)/(6*A);
@@ -115,7 +115,7 @@ public class TwistyUltimate extends Twisty12
     {
     if( mQuats==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement12.FACE_AXIS[status],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementDodecahedron.FACE_AXIS[status],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
